import 'reflect-metadata';
declare type Params<P> = {
    path?: string;
    required?: boolean;
    type?: new (...params: Array<unknown>) => unknown;
    elementType?: new (...args: any[]) => unknown;
    validate?: (property: P) => boolean;
    deserialize?: (jsonValue: unknown) => P;
    serialize?: (property: P) => unknown;
    afterDeserialize?: (deserializedInstance: InstanceType<new (...args: any[]) => unknown>, propertyValue: P) => P;
};
export declare type JsonPropertyMetadata<P = unknown> = {
    name: string;
    path: string;
    type: new (...params: any[]) => unknown;
} & Params<P>;
export default function JsonProperty<P = unknown>(arg?: Params<P> | string): (object: Object, propertyName: string) => void;
export {};
