"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
var common_1 = require("./common");
var JsonProperty_1 = __importDefault(require("./JsonProperty"));
describe('JsonProperty', function () {
    test('JsonProperty property path with no args provided', function () {
        var Class = (function () {
            function Class() {
            }
            __decorate([
                JsonProperty_1.default(),
                __metadata("design:type", String)
            ], Class.prototype, "foo", void 0);
            return Class;
        }());
        var metaData = Reflect.getMetadata(common_1.ReflectMetaDataKeys.TsJacksonJsonProperty, Class);
        expect(metaData).toMatchObject({
            foo: {
                name: 'foo',
                path: 'foo',
                type: String,
            },
        });
    });
    test('JsonProperty property with path provided as string', function () {
        var Class = (function () {
            function Class() {
            }
            __decorate([
                JsonProperty_1.default('a.b.c'),
                __metadata("design:type", Number)
            ], Class.prototype, "foo", void 0);
            return Class;
        }());
        var metaData = Reflect.getMetadata(common_1.ReflectMetaDataKeys.TsJacksonJsonProperty, Class);
        expect(metaData).toMatchObject({
            foo: {
                name: 'foo',
                path: 'a.b.c',
                type: Number,
            },
        });
    });
    test('JsonProperty property with path provided as a part of options argument', function () {
        var Class = (function () {
            function Class() {
            }
            __decorate([
                JsonProperty_1.default({ path: 'a[0]' }),
                __metadata("design:type", Number)
            ], Class.prototype, "foo", void 0);
            return Class;
        }());
        var metaData = Reflect.getMetadata(common_1.ReflectMetaDataKeys.TsJacksonJsonProperty, Class);
        expect(metaData).toMatchObject({
            foo: {
                name: 'foo',
                path: 'a[0]',
                type: Number,
            },
        });
    });
    test('JsonProperty validate param', function () {
        var validate = function (foo) { return foo > 5; };
        var Class = (function () {
            function Class() {
            }
            __decorate([
                JsonProperty_1.default({ validate: validate }),
                __metadata("design:type", Number)
            ], Class.prototype, "foo", void 0);
            return Class;
        }());
        var metaData = Reflect.getMetadata(common_1.ReflectMetaDataKeys.TsJacksonJsonProperty, Class);
        expect(metaData).toHaveProperty('foo.validate', validate);
    });
    test('JsonProperty with type provided as a param', function () {
        var Class = (function () {
            function Class() {
            }
            __decorate([
                JsonProperty_1.default({ type: Array }),
                __metadata("design:type", Number)
            ], Class.prototype, "foo", void 0);
            return Class;
        }());
        var metaData = Reflect.getMetadata(common_1.ReflectMetaDataKeys.TsJacksonJsonProperty, Class);
        expect(metaData).toMatchObject({
            foo: {
                name: 'foo',
                path: 'foo',
                type: Array,
            },
        });
    });
});
